import typeBy from './typeBy'
export const isPromise = (obj: any): Boolean => !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
export const isString = (obj: any) => typeBy(obj) === 'string';
export const isFunction = (obj: any) => typeBy(obj) === 'function';
export const isBoolean = (obj: any) => obj === true || obj === false;
export const isElement = (e: unknown): e is Element => {
  if (typeof Element === 'undefined') return false
  return e instanceof Element
}